'BEISPI05.BAS fr PowerBasic ab Version 2.1
'Die Verwendung der VMenu-Funktionen am Beispiel einer Dateiauswahlbox.
'Public Domain von Thiemo Mttig, Hauptstr. 11, 02627 Hochkirch

'----------------------------------------------------------------------------

$include "Base-Vga.inc"					'Grundfunktionen
$include "FreeFn21.inc"					'fr PowerBasic 2.1
'$include "FreeFont.inc"				'fr PowerBasic 3.2
$include "VMenu.inc"					'grafische Elemente
$include "Maus.inc"					'Maussteuerung

VMenuHell%=89: VMenuFarbe%=65: VMenuDunkel%=161		'neue Farben
VMenuText%=185: VMenuRahmen%=185

call VScreen (13): call VCls (26)			'Grafikmodus ein
Schrift$=LadeFF$("standard.ff1")			'Schrift laden

' Hinweis: Eine andere Schriftart ist jederzeit mglich, allerdings sollte
' sie entweder genauso gro sein, oder die Funktion VMenuDatei$ muss
' angepasst werden!

Test$=VMenuDatei$ (-1,-1,"","Datei whlen",Schrift$)	'Funktion ausfhren

call VScreen (0)					'zurck zum Textmodus
? "Gewhlte Datei: ";Test$				'Ergebnis anzeigen

'----------------------------------------------------------------------------

function VMenuDatei$ (VX%, VY%, Maske$, Titel$, VMFont$)
  if VX%>129 or VX%<0 then VX%=65			'evtl. zentrieren
  if VY%>77 or VY%<0 then VY%=39
  dim f$(0:999)						'maximal 1000 Dateien
  if Maske$="" then Maske$="*.*"			'alle Dateien suchen?
  f$(0)=dir$(Maske$)					'erste Datei suchen
  if f$(0)="" then exit function			'Fkt. evtl. abbrechen
  call VMenuwindow (VX%,VY%,VX%+190,VY%+122,3,Titel$,VMFont$)
  call VMenuTief (VX%+9,VY%+25,VX%+91,VY%+113,1,"","")
  call VMenuButton (VX%+97,VY%+25,VX%+109,VY%+45,1,chr$(24),VMFont$)
  call VMenuWindow (VX%+97,VY%+45,VX%+109,VY%+93,1,"","")
  call VMenuButton (VX%+97,VY%+93,VX%+109,VY%+113,1,chr$(25),VMFont$)
  call VMenuButton (VX%+114,VY%+25,VX%+181,VY%+45,2,"OK",VMFont$)
  call VMenuButton (VX%+114,VY%+55,VX%+181,VY%+75,2,"Abbruch",VMFont$)
  for m%=1 to 1000
    f$(m%)=dir$						'weitere Datei suchen
    if f$(m%)="" then anz%=m%-1: exit for		'die Anzahl sichern
  next
  array sort f$(0) for anz%+1: aa1%=-1			'Dateinamen sortieren
  do
    if a1%<>aa1% then
      call VBoxGefuellt (VX%+13,VY%+29,VX%+87,VY%+109,VMenuFarbe%)
      for m%=0 to 7
	call VFreeText1 (VX%+15,VY%+30+m%*10,VMenuText%,f$(m%+a1%),VMFont$)
      next
      aa1%=a1%
    else
      call VBox (VX%+13,VY%+29+(aa%-a1%)*10,VX%+87,VY%+39+(aa%-a1%)*10,VMenuFarbe%,-1)
    end if
    call VBox (VX%+13,VY%+29+(a%-a1%)*10,VX%+87,VY%+39+(a%-a1%)*10,VMenuHell%,-1)
    aa%=a%
    call MausEin: call WarteAufMaus
    call MausUndTasten (i$, MsTst%, DClick%)		'Maus & Taste lesen
    call MausAus
    if i$<>"" then
      select case i$   					'Taste auswerten
	case chr$(27): VMenuDatei$="": exit loop	'Esc = Abbruch
        case chr$(13)					'Enter = ausgewhlt
	  VMenuDatei$=f$(a%): exit loop
        case chr$(0,80): if a%<anz% then incr a%	'Pfeil nach unten
          if a%>a1%+7 then incr a1%,7
          if anz%>8 and a1%>anz%-7 then a1%=anz%-7
        case chr$(0,72): if a%>0 then decr a%		'Pfeil nach oben
          if a%<a1% then decr a1%,7
          if a1%<0 then a1%=0
        case else
      end select
    else
      if MausX%>VX%+113 and MausX%<VX%+182 and mausy%>VY%+24 and MausY%<VY%+46 then
	call VMenuTief (VX%+114,VY%+25,VX%+181,VY%+45,1,"OK",VMFont$)
	call WarteAufMaus: VMenuDatei$=f$(a%): exit loop
      elseif MausX%>VX%+113 and MausX%<VX%+182 and mausy%>VY%+54 and MausY%<VY%+76 then
	call VMenuTief (VX%+114,VY%+55,VX%+181,VY%+75,1,"Abbruch",VMFont$)
        call WarteAufMaus: VMenuDatei$="": exit loop
      elseif MausX%>VX%+96 and MausX%<VX%+110 and mausy%>VY%+24 and MausY%<VY%+46 then
        decr a1%,7: if a1%<0 then a1%=0
        if a%>a1%+7 then a%=a1%+7
      elseif MausX%>VX%+96 and MausX%<VX%+110 and mausy%>VY%+92 and MausY%<VY%+114 then
        if anz%>8 then
          incr a1%,7: if a1%>anz%-7 then a1%=anz%-7
          if a%<a1% then a%=a1%
        end if
      elseif MausX%>VX%+12 and MausX%<VX%+88 and mausy%>VY%+28 and MausY%<VY%+110 then
        a%=(MausY%-VY%-29)\10+a1%: if a%<a1% then a%=a1%
        if a%>a1%+7 then a%=a1%+7
        if a%>anz% then a%=anz%
	if DClick% then VMenuDatei$=f$(a%): exit loop
      end if
    end if
  loop
end function