sub VScreen (Modus%)					'Ersatz fr SCREEN
  if Modus%=13 then
    reg 1,&H0013: call interrupt &H10			'Modus 13h ein
    def seg=&HA000					'Segment einstellen
  else
    def seg						'Segment auf Null
    reg 1,&H0003: call interrupt &H10			'Textmodus 80x25 ein
    screen 0: width 80: cls				'nur zur Sicherheit
  end if
end sub

sub VCls (Farbe%)					'Ersatz fr CLS
  def seg=&HA000					'neue Segmentadresse
  Temp$=string$(640,Farbe%)				'nur ein Hilfs-String
  for i%=0 to 99					'100 Schritte
    poke$ i%*640,Temp$					'Bildzeilen zeichnen
  next
end sub

sub VPset (x%,y%,Farbe%)				'Ersatz fr PSET
  if x%<0 or x%>319 or y%<0 or y%>199 then exit sub	'Koordinaten prfen
  poke y%*320+x%,Farbe%					'Punkt setzen
end sub

sub VBox (x1%,y1%,x2%,y2%,f%,ff%)			'Ersetzt LINE(),B[F]
  if x1%>x2% then swap x1%,x2%
  if y1%>y2% then swap y1%,y2%
  if x1%<0 or x2%>319 or y1%<0 or y2%>199 then exit sub
  for i%=y1%+1 to y2%-1					'Zeichne die zwei
    call vpset(x1%,i%,f%): call vpset(x2%,i%,f%)	'vertikalen Linien.
  next
  poke$ 320*y1%+x1%,string$(x2%-x1%+1,f%)		'Zeichne horizon-
  poke$ 320*y2%+x1%,string$(x2%-x1%+1,f%)		'tale Linien.
  if ff%>-1 then					'Fllen?
    for i%=y1%+1 to y2%-1				'Flle Rechteck mit
      poke$ 320*i%+x1%+1,string$(x2%-x1%-1,ff%)		'der Farbe ff%.
    next
  end if
end sub

sub VBoxGefuellt (x1%,y1%,x2%,y2%,f%)			'Ersatz fr LINE(),BF
  if x1%>x2% then swap x1%,x2%
  if y1%>y2% then swap y1%,y2%
  if x1%<0 or x2%>319 or y1%<0 or y2%>199 then exit sub
  for z%=y1% to y2%					'Zeichne Rechteck mit
    poke$ 320*z%+x1%,string$(x2%-x1%+1,f%)		'der Farbe f%.
  next
end sub
