'FF-EDIT.BAS fr PowerBasic ab Version 3.2
'Editor zum Erstellen und ndern von Schriften fr die FreeFont-Funktionen.
'Public Domain von Thiemo Mttig, Hauptstr. 11, 02627 Hochkirch

'----------------------------------------------------------------------------

'$compile exe "FF-Edit.exe"				'EXE erzeugen
$cpu 80286						'optimal fr 286er
$float emulate						'auch ohne Coprozess.
$optimize size						'Gre optimieren
$lib all off						'keine Bibliotheken
$error all off						'Fehlerprotokolle aus
$string 32						'maximale Stringlnge
$com 0							'minimale Com-Gre
$sound 1						'minimale Sound-Gre
$option cntlbreak off					'Strg+Untbr aus
$event off						'keine Ereignisse
defint a-z						'alle Zahlen Integer

$include "Base-Vga.inc"					'Basisfunktionen
$include "Maus.inc"					'Maussteuerung
$include "FreeFont.inc"					'freie Schriften
$include "VMenu.inc"					'Menfunktionen
VMenuHell=2: VMenuFarbe=0: VMenuDunkel=141		'andere Farben
VMenuText=15: VMenuRahmen=93

%ColorTrue=15: %ColorFalse=237				'globale Konstanten
shared LdFl$, SvFl$, NormFF$, Marks&			'globale Variablen

if MausVorhanden=0 then					'ohne Maus geht nix
  ?"Eine Maus wird unbedingt bentigt!": end
end if

do							'Hauptschleife

VScreen 0						'Textmodus ein
TextRahmen 14: ? string$(74,205)			'Rahmen darstellen
?"FreeFont-Editor v1.3": ? string$(74,196)
?"Public Domain fr PowerBasic ab Version 2.1"
?"Meine Anschrift: Thiemo Mttig, Hauptstrae 11, 02627 Hochkirch"
? string$(74,205): ?: ?
?"1 - Neue Schrift FNT oder FF1 mit fester Breite"
?"2 - Neue Schrift FF2 mit variabler Breite"
?"3 - Schrift bearbeiten"
?"4 - Konvertieren und Eigenschaften ndern"
?"5 - Schrift testen"
?"6 - Zwei Schriften vergleichen"
?"7 - Schrift lschen"
?"0 - Ende": ?
?"Bitte drcken Sie die gewnschte Zahl...";

Auswahl$=""
while len(Auswahl$)=0: Auswahl$=inkey$: wend		'auf Taste warten
select case Auswahl$					'Taste auswerten

  case "1", chr$(0,59)					'neue Schrift FNT/FF1
    TextRahmen 10					'Rahmen zeichnen
    if len(dir$("*.F*"))>0 then
      files"*.F*"					'vorhandene Dateien
      ?: ?"Diese Dateien existieren bereits."
    end if
    input"Geben Sie einen neuen Dateinamen ein: ",SvFl$
    if len(SvFl$)=0 then exit select
    if tally(SvFl$,".")=0 then
      ?"Soll diese Schrift im Binrformat FNT gespeichert werden? (J/n)"
      i$=input$(1)
      if i$<>"n" then SvFl$=SvFl$+".FNT" else SvFl$=SvFl$+".FF1"
    else
      SvFl$=ucase$(SvFl$)
    end if
    if len(dir$(SvFl$))>0 then
      ?"Soll die bereits existierende Datei berschrieben werden? (j/N)"
      i$=input$(1): if i$<>"j" then exit select
    end if
    input"Hhe der Buchstaben           (3 bis 20): ",EFHoe
    if EFHoe<3 or EFHoe>20 then EFHoe=16
    if tally(SvFl$,".FNT") then
      EFBre=8: EFPla=1
    else
      input"Breite der Buchstaben          (2 bis 8): ",EFBre
      if EFBre<2 or EFBre>8 then EFBre=8
      input"Platz zwischen den Buchstaben (0 bis 10): ",EFPla
      if EFPla<0 or EFPla>10 then EFPla=1
    end if
    Font$=chr$(EFHoe,EFBre,EFPla)+string$(256*EFHoe,0)
    if EditFF (1,EFBre,EFHoe,EFBre,EFPla,Font$) then
      SaveFF SvFl$,EFBre,EFHoe,EFBre,EFPla
    end if

  case "2", chr$(0,60)					'neue Schrift FF2
    TextRahmen 10
    if len(dir$("*.FF2"))>0 then
      files"*.FF2": ?					'vorhandene Dateien
      ?"Diese Dateien existieren bereits."
    end if
    input"Geben Sie einen neuen Dateinamen ein: ",SvFl$
    if len(SvFl$)=0 then exit select
    if tally(SvFl$,".")=0 then SvFl$=SvFl$+".FF2"
    if len(dir$(SvFl$))>0 then
      ?"Soll diese Datei berschrieben werden? (j/N)"
      i$=input$(1): if i$<>"j" then exit select
    end if
    input"Hhe der Buchstaben           (3 bis 20): ",EFHoe
    if EFHoe<3 or EFHoe>20 then EFHoe=16
    input"Breite des Leerzeichens       (1 bis 20): ",EFBre
    if EFBre<1 or EFBre>20 then EFBre=3
    input"Platz zwischen den Buchstaben (0 bis 10): ",EFPla
    if EFPla<0 or EFPla>10 then EFPla=1
    Font$=chr$(EFHoe,EFBre,EFPla)+string$(256*EFHoe,0)
    if EditFF (2,8,EFHoe,EFBre,EFPla,Font$) then
      SaveFF SvFl$,8,EFHoe,EFBre,EFPla
    end if

  case "3", chr$(0,61)					'Schrift laden
    LdFl$=FFWahl$("*.F*")				'Datei auswhlen
    if len(LdFl$)=0 then exit select
    input"Neuer Dateiname oder Enter: ",SvFl$		'neuer Dateiname
    if len(SvFl$)=0 then SvFl$=LdFl$			'Datei berschreiben
    if tally(SvFl$,".")=0 then
      SvFl$=SvFl$+right$(LdFl$,4)			'Endung ergnzen
    end if
    Font$=LadeFF$(LdFl$)				'Schriftart laden
    EFHoe=FFAttribut(Font$,1)				'Parameter auslesen
    EFBre=FFAttribut(Font$,2)
    EFPla=FFAttribut(Font$,3)
    if right$(LdFl$,1)="2" then				'abhngig vom Typ
      zt=2: zx=8					'Schrifttyp 2
    else
      zt=1: zx=EFBre					'Schrifttyp 1
    end if
    if EditFF(zt,zx,EFHoe,EFBre,EFPla,Font$) then
      SaveFF SvFl$,zx,EFHoe,EFBre,EFPla
    end if

  case "4", chr$(0,62)					'Konvertieren
    LdFl$=FFWahl$("*.F*")				'Datei auswhlen
    if len(LdFl$)=0 then exit select
    TextRahmen 12					'neuer Bildschirm
    ?"Die Schrift ";LdFl$;" wird jetzt umgewandelt."
    ?"Bei Konvertierung zwischen den Formaten bitte mit Endung eingeben."
    input"Neuer Dateiname: ",SvFl$			'neuer Dateiname
    if len(SvFl$)=0 then exit select
    if tally(SvFl$,".")=0 then
      SvFl$=SvFl$+right$(LdFl$,4)			'Endung ergnzen
    else
      SvFl$=ucase$(SvFl$)
    end if
    if len(dir$(SvFl$))>0 then
      ?"Soll diese Datei wirklich berschrieben werden? (j/N)"
      i$=input$(1): if i$<>"j" then exit select
    end if
    Font$=LadeFF$(LdFl$)				'Schriftart laden
    EFHoe=FFAttribut(Font$,1)				'Parameter auslesen
    EFBre=FFAttribut(Font$,2)
    EFPla=FFAttribut(Font$,3)
    ?"Hhe der Buchstaben:";EFHoe			'Parameter zeigen
    if right$(LdFl$,1)="2" then
      ?"Breite des Leerzeichens:";EFBre
    else
      ?"Breite der Buchstaben:";EFBre
    end if
    ?"Platz zwischen den Buchstaben:";EFPla
    input"neue Hhe: ",h: if h<3 or h>20 then h=EFHoe	'neue Parameter
    if right$(SvFl$,3)="FNT" then
      b=8
    else
      input"neue Breite: ",b: if b<2 or b>8 then b=EFBre
      input"neuer Platz: ",p: if p>10 then p=EFPla
    end if
    ?: ?"Konvertierung luft..."
    VScreen 13						'im Grafikmodus
    if tally(SvFl$,".FNT") then Temp$="" else Temp$=chr$(h,b,p)
    nx=fix((b-EFBre)/2)+100: ny=fix((h-EFHoe)/2)+100
    for m=0 to 255
      VBoxGefuellt 100,100,99+b,99+h,%ColorFalse
      if right$(LdFl$,1)="2" then
        VFreeText2 100,ny,%ColorTrue,chr$(m),Font$: b=8
      else
        VFreeText1 nx,ny,%ColorTrue,chr$(m),Font$
      end if
      for ou=100 to 99+h
        TxByte=0
        for lr=0 to b-1
          if right$(SvFl$,1)="2" then
            if peek(ou*320+lr+100)=%ColorTrue then bit set TxByte,lr
          else
            if peek(ou*320+lr+100)=%ColorTrue then bit set TxByte,7-lr
          end if
        next
        Temp$=Temp$+chr$(TxByte)
      next
    next
    open SvFl$ for binary as #1
    put$ #1,Temp$: put$ #1,"": close			'Datei neu schreiben
    Temp$="": Font$=""

  case "5", chr$(0,63)					'Schrift testen
    LdFl$=FFWahl$("*.F*")				'Datei auswhlen
    if len(LdFl$)=0 then exit select
    Font$=LadeFF$(LdFl$)				'Schriftart laden
    VScreen 13: VCls 0					'Grafikmodus ein
    VPrint 9,8,"Bitte einen Text eingeben:",15
    VPrint 17,15,LdFl$,15
    t$="AaBbCcXxYyZz 123"
    do
      VBoxGefuellt 0,80,319,120,28			'weier Balken
      if right$(LdFl$,1)="2" then			'abhngig vom Typ
        VFreeText2 10,90,0,t$,Font$			'den Text anzeigen
      else
        VFreeText1 10,90,0,t$,Font$
      end if
      do: i$=inkey$: loop while len(i$)=0		'auf Taste warten
      select case i$
        case chr$(27): exit loop			'Esc = Ende
        case chr$(8)					'Buchstabe lschen
          if len(t$)>0 then t$=left$(t$,len(t$)-1)
        case chr$(13)
        case chr$(1) to chr$(254): t$=t$+i$		'Buchstabe anfgen
        case else
      end select
    loop

  case "6", chr$(0,64)					'Schrift vergleichen
    LdFl$=FFWahl$("*.F*")				'Datei auswhlen
    if len(LdFl$)=0 then exit select
    LdFl2$=FFWahl$("*.F*")				'zweite Datei whlen
    if len(LdFl2$)=0 then exit select
    Font1$=LadeFF$(LdFl$)				'erste Schrift laden
    Font2$=LadeFF$(LdFl2$)				'zweite Schrift laden
    VScreen 13: VCls 15					'Grafikmodus ein
    for m=0 to 255					'alle Zeichen zeigen
      a=(m mod 35)*9+3 : b=fix(m/35)*25+1
      if right$(LdFl$,1)="2" then
        VFreeText2 a,b,12,chr$(m),Font1$
      else
        VFreeText1 a,b,12,chr$(m),Font1$		'die erste hellgrn
      end if
      if right$(LdFl2$,1)="2" then
        VFreeText2 a,b,0,chr$(m),Font2$
      else
        VFreeText1 a,b,0,chr$(m),Font2$			'die zweite schwarz
      end if
    next
    VPrint 23,25,LdFl$,12: VPrint 24,25,LdFl2$,15
    i$=input$(1)					'auf Taste warten

  case "7", chr$(0,65)					'Schrift lschen
    LdFl$=FFWahl$("*.F*")				'Datei auswhlen
    if len(LdFl$)=0 then exit select
    input"Wollen Sie diese Schrift wirklich lschen? : ",i$
    if ascii(ucase$(i$))=74 then kill LdFl$		'nur wenn j gedrckt

  case "0", chr$(0,68), chr$(27)			'Programm beenden
    view text (1,1)-(80,25): color 7,0: cls: end

  case else
end select

loop							'Ende Hauptschleife

'----------------------------------------------------------------------------

function EditFF (EFTyp,Breite,EFHoe,EFBre,EFPla,Font$)
VScreen 13: VBox 0,0,319,199,2,-1
for m=0 to 255
  a=(m mod 35)*9+3 : b=fix(m/35)*21+3
  VBoxGefuellt a,b,a+Breite-1,b+EFHoe-1,%ColorFalse
  if EFTyp=1 then
    VFreeText1 a,b,%ColorTrue,chr$(m),Font$
  else
    VFreeText2 a,b,%ColorTrue,chr$(m),Font$
  end if
next
if EFTyp=1 then
  Temp$=str$(EFHoe)+" hoch,"+str$(EFBre)+" breit,"+str$(EFPla)+" Platz"
else
  Temp$=str$(EFHoe)+" hoch,"+str$(EFBre)+" Leerz,"+str$(EFPla)+" Platz"
end if
VPrint 20,15,"FreeFont-Edit  Mad/OS",10
VPrint 22,15,ltrim$(Temp$),15
VMenuTief 3,179,94,196,2,"",""
VPrint 24,2,"Zeichen:",15
VMenuButton 106,179,213,196,2,"",""
VPrint 24,15,"F2 Speichern",15
VMenuButton 218,179,316,196,2,"",""
VPrint 24,29,"F10 Abbruch",15

do
  MausEin: i$="": MsTst=0: WarteAufMaus
  while len(i$)=0 and MsTst=0				'auf Taste warten
    i$=inkey$: MsTst=Clicked				'Taste & Maus lesen
    Edz=fix((MausX-3)/9)+fix((MausY-3)/21)*35		'Zeichen berechnen
    if Edz<0 then Edz=0
    if Edz>255 then Edz=255
    if Edz<>OldEdz and Edz<>7 then			'wenn es sich ndert
      VPrint 24,11,chr$(Edz),15: OldEdz=Edz		'Zeichen darstellen
    end if
  wend
  MausAus

  if MsTst then
    if MausX>105 and MausY>178 and MausX<214 and MausY<197 then
      EditFF=1: exit loop
    elseif MausX>217 and MausY>178 and MausX<317 and MausY<197 then
      EditFF=0: exit loop
    elseif MausX>100 and MausY>147 then
    else
      EinzelEdit Edz,Breite,EFHoe			'Zeichen editieren
    end if
  elseif len(i$)>0 then
    select case i$					'Taste auswerten
      case chr$(0,60): EditFF=1: exit loop		'F2 = Speichern
      case chr$(27), chr$(0,68)				'Esc, F10 = Abbruch
        EditFF=0: exit loop

      case chr$(0,83)					'Entf = lschen
        x=(Edz mod 35)*9+3: y=fix(Edz/35)*21+3
        VBoxGefuellt x,y,x+EFBre-1,y+EFHoe-1,%ColorFalse

      case chr$(0,61)					'F3 = Spiegeln
        VPrint 20,15,"Schrift wird gespiegelt! ",12
        for m=0 to 255
          a=(m mod 35)*9+3 : b=fix(m/35)*21+2
          for ZeiHoe=1 to EFHoe
            Temp$=peek$((b+ZeiHoe)*320+a,Breite): Temp2$=""
            for ZeiBre=0 to Breite-1
              Temp2$=Temp2$+mid$(Temp$,Breite-ZeiBre,1)
            next
            poke$ (b+ZeiHoe)*320+a,Temp2$
          next
        next
        VPrint 20,15,"FreeFont-Edit  Mad/OS",10

      case chr$(0,62)					'F2 = Invertieren
        for m=0 to 255
          a=(m mod 35)*9+2 : b=fix(m/35)*21+2
          for ZeiHoe=1 to EFHoe
            for ZeiBre=1 to Breite
              if peek((b+ZeiHoe)*320+a+ZeiBre)=%ColorTrue then
                poke (b+ZeiHoe)*320+a+ZeiBre,%ColorFalse
              else
                poke (b+ZeiHoe)*320+a+ZeiBre,%ColorTrue
              end if
            next
          next
        next

      case chr$(0,63)					'F5 = Kopieren
        VPrint 20,15,"Wohin kopieren?          ",12
        MausEin: i$="": MsTst=0: WarteAufMaus
        while len(i$)=0 and MsTst=0			'auf Taste warten
          i$=inkey$: MsTst=Clicked			'Taste & Maus lesen
          Edz2=fix((MausX-3)/9)+fix((MausY-3)/21)*35	'Zeichen berechnen
          if Edz2<0 then Edz2=0
          if Edz2>255 then Edz2=255
          if Edz2<>OldEdz and Edz2<>7 then		'wenn es sich ndert
            VPrint 24,11,chr$(Edz2),15: OldEdz=Edz2	'Zeichen darstellen
          end if
        wend
        MausAus
        VPrint 20,15,"FreeFont-Edit  Mad/OS",10
        if i$=chr$(27) or MsTst>1 then exit select
        for ou=0 to EFHoe-1
          Temp$=peek$((ou+fix(Edz/35)*21+3)*320+(Edz mod 35)*9+3, 8)
          poke$ (ou+fix(Edz2/35)*21+3)*320+(Edz2 mod 35)*9+3, Temp$
        next

      case chr$(1) to chr$(255)				'Zeich. direkt whlen
        EinzelEdit ascii(i$),Breite,EFHoe		'Zeichen editieren
    end select
  end if
loop
end function

'----------------------------------------------------------------------------

sub SaveFF (SvFl$,xBreite,EFHoe,EFBre,EFPla)		'Schrift speichern
  open SvFl$ for binary as #1				'Datei ffnen
  if tally(SvFl$,".FNT")=0 then
    put$ #1,chr$(EFHoe,EFBre,EFPla)			'Parameter schreiben
  end if
  if right$(SvFl$,1)="2" then SvTyp=2 else SvTyp=1
  for m=0 to 255					'Zeichen abarbeiten
    for ou=0 to EFHoe-1
      TxByte=0
      Temp??=(ou+fix(m/35)*21+3)*320+(m mod 35)*9+3	'Berechnung vorziehen
      for lr=0 to xBreite-1
        if peek(Temp??+lr)=%ColorTrue then		'ein Pixel prfen
          if SvTyp=1 then				'abhngig vom Typ
            bit set TxByte,7-lr				'ein Bit setzen
          else
            bit set TxByte,lr
          end if
        end if
      next
      put$ #1,chr$(TxByte)				'ein Byte speichern
    next
    a=(m mod 35)*9+3: b=fix(m/35)*21+3			'grafischer Effekt
    VBoxGefuellt a,b,a+7,b+EFHoe-1,14
  next
  put$ #1,"": close #1					'am Ende abschneiden
end sub

'----------------------------------------------------------------------------

sub EinzelEdit (Edz,Breite,EFHoe)			'Zeichen editieren
  Saves1$=peek$(0,32000): Saves2$=peek$(32000,32000)	'Bildschirm sichern
  dim ThisBST?(1:EFHoe)					'lokales Array
  for ou=0 to EFHoe-1					'Array fllen
    for lr=0 to Breite-1
      if peek((ou+fix(Edz/35)*21+3)*320+(lr+(Edz mod 35)*9+3))=%ColorTrue then
        bit set ThisBST?(ou+1),lr
      end if
    next
  next
  VMenuWindow 98,4,229,196,2,"",""			'Fenster darstellen
  VMenuTief 202,11,221,22+EFHoe,1,"",""
  VMenuTief 202,170,221,189,1,"",""
  for ou=0 to EFHoe-1					'Zeichen vergrern
    for lr=0 to Breite-1
      if bit(ThisBST?(ou+1),lr) then			'wenn Bit gesetzt
        f=%ColorTrue					'Farbe = hell
      else
        f=%ColorFalse					'Farbe = dunkel
      end if
      VBoxGefuellt lr*9+106,ou*9+11,lr*9+113,ou*9+18,f
      VPset lr+208,ou+17,f
    next
    VBoxGefuellt 190,ou*9+11,195,ou*9+18,104-95*bit(Marks&,ou)
  next
  VPrint 19,26,"ASC",15
  VPrint 20,26,ltrim$(str$(Edz)),15			'Ascii-Code zeigen
  if Edz<>7 then VPrint 23,27,chr$(Edz),15		'Original zeigen
  WarteAufMaus
  do
    MausEin: i$="": MsTst=0
    while len(i$)=0 and MsTst=0				'auf Eingabe warten
      i$=inkey$: MsTst=Clicked
    wend
    MausAus
    if len(i$)>0 then
      select case i$					'Taste auswerten
        case chr$(27),chr$(0,68)			'Esc, F10 = Abbruch
          poke$ 0,Saves1$: poke$ 32000,Saves2$		'Bild restaurieren
          exit sub					'und abbrechen
        case chr$(13),chr$(0,60): exit loop		'Enter, F2 = Fertig
        case chr$(0,83)					'Entf = lschen
	  for ou=0 to EFHoe-1
	    for lr=0 to Breite-1
	      x3=lr*9+106: y3=ou*9+11
              VBoxGefuellt x3,y3,x3+7,y3+7,%ColorFalse
	    next
            VBoxGefuellt 208,17,215,16+EFHoe,%ColorFalse
	  next
      end select
    elseif MsTst then					'Maus auswerten
      if MausX>188 and MausX<197 then			'Marker verndern
        y=fix((MausY-11)/9)
        if y<0 then y=0
        if y>19 then y=19
        bit toggle Marks&, y
        VBoxGefuellt 190,y*9+11,195,y*9+18,104-95*bit(Marks&,y)
        WarteAufMaus
      elseif MausX>102 and MausX<180 then		'Zeichen verndern
        x=fix((MausX-106)/9):y=fix((MausY-11)/9)
        if x<0 then x=0
        if y<0 then y=0
        if x=>Breite then x=Breite-1
        if y=>EFHoe then y=EFHoe-1
        if MsTst=1 then f=%ColorTrue else f=%ColorFalse
        VBoxGefuellt x*9+106,y*9+11,x*9+113,y*9+18,f
        VPset x+208,y+17,f
      elseif MausX<85 or MausX>229 then
        exit loop					'EinzelEdit beenden
      end if
    end if
  loop
  for ou=0 to EFHoe-1					'das Zeichen sichern
    for lr=0 to Breite-1
      if peek(lr*9+106+(ou*9+11)*320)=%ColorTrue then
        bit set ThisBST?(ou+1), lr
      else
        bit reset ThisBST?(ou+1),lr
      end if
    next
  next
  poke$ 0,Saves1$: poke$ 32000,Saves2$			'Bild restaurieren
  for ou=0 to EFHoe-1					'Zeichen bernehmen
    for lr=0 to Breite-1
      if bit(ThisBST?(ou+1),lr) then f=%ColorTrue else f=%ColorFalse
      poke (ou+fix(Edz/35)*21+3)*320+(lr+(Edz mod 35)*9+3),f
    next
  next
end sub

'----------------------------------------------------------------------------

function FFWahl$ (Maske$)				'Datei auswhlen
  if dir$(Maske$)="" then exit function
  dim f$(1:100), Art(1:100,1:3)				'maximal 100 Dateien
  f$(1)=dir$(Maske$): m=1: w=1: w1=1			'erste Datei suchen
  do
    if len(f$(m))=0 then exit loop
    incr m: f$(m)=dir$					'weitere Datei suchen
  loop: Anz=m-1
  array sort f$(1) for Anz				'die Liste sortieren
  for m=1 to Anz
    open f$(m) for binary as #1				'jede Datei ffnen
    get$ #1,3,Temp$					'Parameter auslesen
    if tally(f$(m),".FNT") then
      Art(m,1)=lof(1)\256: Art(m,2)=8: Art(m,3)=1	'beim Typ FNT
    else
      Art(m,1)=ascii(left$(Temp$,1))
      Art(m,2)=ascii(mid$(Temp$,2,1))
      Art(m,3)=ascii(mid$(Temp$,3,1))
    end if
    close #1
  next
  TextRahmen 10: locate 1,11
  ?"Schrift           Hhe   Breite/Leerz.    Platz"
  do
    for m=0 to 16					'Dateiliste anzeigen
      if w=m+w1 then color 10,1 else color 10,0		'Markierung farbig
      if right$(f$(m+w1),1)="2" then
        color 14					'Typ 2 wird gelb
      elseif right$(f$(m+w1),3)="FNT" then
        color 11
      end if
      locate m+3,10
      ? " ";left$(f$(m+w1)+space$(20),18);_
        Art(m+w1,1),Art(m+w1,2),Art(m+w1,3);
    next
    i$="": while len(i$)=0: i$=inkey$: wend		'auf Taste warten
    select case i$					'Taste auswerten
      case chr$(0,72): if w>1 then decr w		'Pfeil nach oben
        if w1>w then decr w1
      case chr$(0,80): if w<Anz then incr w		'Pfeil nach unten
        if w1+16<w then incr w1
      case chr$(0,71): w=1: w1=1			'Position 1
      case chr$(0,79): w=Anz				'Ende
        if w1+16<w then w1=w-16
      case chr$(0,73): decr w,16			'Bild nach oben
        if w<1 then w=1
        if w1>w then w1=w
      case chr$(0,81): incr w,16			'Bild nach unten
        if w>Anz then w=Anz
        if w1+16<w then w1=w-16
      case chr$(27): FFWahl$="": exit loop		'Esc = Abbruch
      case chr$(13): FFWahl$=f$(w): exit loop		'Enter = diese Datei
      case else
    end select
  loop: color ,0: locate 21,11
end function

'----------------------------------------------------------------------------

sub TextRahmen (Farbe)					'Rahmen im Textmodus
  view text (1,1)-(80,25): color Farbe,0
  locate 1,1: ?"";string$(78,196);"";
  for Zeile=2 to 24
    locate Zeile,1: ?"";space$(78);"";
  next
  locate 25,1: ?"";string$(78,196);"";
  view text (4,3)-(78,23)
end sub

'----------------------------------------------------------------------------

sub VPrint (x, y, Text$, Farbe)				'Textausgabe in VGA
  reg 1,4865: reg 2,Farbe: reg 3,len(Text$)		'Register einstellen
  reg 4,(x-1)*256+y-1: reg 7,strptr(Text$)
  reg 9,strseg(Text$): call interrupt &H10		'Interrupt aufrufen
end sub