'FREEFN21.INC fr PowerBasic ab Version 2.1
'Freie Schriftarten fr jeden beliebigen Grafikmodus inklusive VGA-Modus 13h.
'Public Domain von Thiemo Mttig, Hauptstr. 11, 02627 Hochkirch

'----------------------------------------------------------------------------

function LadeFF$ (Dateiname$)				'Schriftart laden
  if instr(Dateiname$,".")=0 then
    Dateiname$=Dateiname$+".FF1"			'Endung ergnzen
  end if
  Dateinummer%=freefile					'nchste Dateinummer
  open Dateiname$ for binary as Dateinummer%
    if lof(Dateinummer%)=0 then
      close Dateinummer%: kill Dateiname$		'leere Datei lschen
      exit function
    end if
    get$ Dateinummer%, 8174, Daten$			'alle Daten auslesen
  close Dateinummer%
  if (len(Daten$) mod 256)=0 then
    LadeFF$ = chr$(len(Daten$)\256,8,1) + Daten$	'fr Binrdateien
  else
    LadeFF$ = Daten$					'fr FF-Schriften
  end if
end function

'----------------------------------------------------------------------------

function FFAttribut% (Font$, Nummer%)			'Attribute der
  FFAttribut% = ascii(mid$(Font$,Nummer%,1))		'Schrift ermitteln
end function

'----------------------------------------------------------------------------

sub FreeText1 (x%, y%, Farbe%, Text$, Font$)		'normaler Text
  if len(Font$)<771 then exit sub			'Parameter berprfen
  Hoe%=asc(Font$)					'Hhe auslesen
  Bre%=asc(mid$(Font$,2,1))				'Breite auslesen
  Pla%=asc(mid$(Font$,3,1))				'Zwischenrume lesen
  dim Maske%(0:7)					'Bitmaske erzeugen
  for i%=0 to 7: Maske%(i%)=2^(7-i%): next		'und initialisieren
  def seg=strseg(Font$): FPtr&=strptr(Font$)+3		'Pointer auf Font$
  for Buchst%=1 to len(Text$)				'den Text abarbeiten
    BuchstZ%=ascii(mid$(Text$,Buchst%,1))*Hoe%
    BuchstX%=x%+(Buchst%-1)*(Bre%+Pla%) 		'x fr diesen Buchst.
    for FFStrOU%=0 to Hoe%-1
      TextByte%=peek(FPtr&+BuchstZ%+FFStrOU%)		'ein Byte von Text$
      BuchstY%=y%+FFStrOU%
      for FFStrLR%=0 to Bre%-1
	if (TextByte% and Maske%(FFStrLR%)) then	'wenn Bit gesetzt ist
	  pset (BuchstX%+FFStrLR%, BuchstY%), Farbe%	'Punkt zeichnen
	end if
      next						'nchster Punkt
    next						'nchste Zeile
  next							'nchster Buchstabe
  def seg						'Segment zurcksetzen
end sub

'----------------------------------------------------------------------------

sub FreeText2 (x%, y%, Farbe%, Text$, Font$)		'flexibler Text
  if len(Font$)<771 then exit sub
  Hoe%=asc(Font$)					'Hhe auslesen
  Bre%=asc(mid$(Font$,2,1))				'Breite Leerzeichen
  Pla%=asc(mid$(Font$,3,1))				'Breite Zwischenrume
  BuchstX%=x%
  dim Maske%(0:7)					'Bitmaske erzeugen
  for i%=0 to 7: Maske%(i%)=2^i%: next			'und initialisieren
  def seg=strseg(Font$): FPtr&=strptr(Font$)+3		'Pointer von Font$
  for Buchst%=1 to len(Text$)				'den Text abarbeiten
    BuchstZ%=ascii(mid$(Text$,Buchst%,1))*Hoe%
    for FFStrOU%=0 to Hoe%-1
      TextByte%=peek(FPtr&+BuchstZ%+FFStrOU%)		'ein Byte aus Font$
      if TextByte%=0 then				'Leerz. bergehen
      elseif TextByte%>127 then: Gox%=8			'und sonst die Breite
      elseif TextByte%>63 then : Gox%=max%(Gox%,7)	'auswerten
      elseif TextByte%>31 then : Gox%=max%(Gox%,6)
      elseif TextByte%>15 then : Gox%=max%(Gox%,5)
      elseif TextByte%>7 then  : Gox%=max%(Gox%,4)
      elseif TextByte%>3 then  : Gox%=max%(Gox%,3)
      elseif TextByte%>1 then  : Gox%=max%(Gox%,2)
      elseif TextByte%=1 then  : Gox%=max%(Gox%,1)
      end if
      BuchstY%=y%+FFStrOU%
      for FFStrLR%=0 to 7
	if (TextByte% and Maske%(FFStrLR%)) then	'wenn Bit gesetzt ist
	  pset(BuchstX%+FFStrLR%, BuchstY%), Farbe%	'Punkt zeichnen
	end if
      next						'nchster Punkt
    next						'nchste Zeile
    if Gox%=0 then					'ein Leerzeichen?
      incr BuchstX%,Bre%-Pla%
    else
      incr BuchstX%,Gox%+Pla%				'plus variable Breite
      Gox%=0
    end if
  next							'nchster Buchstabe
  def seg						'Segment zurcksetzen
end sub

'----------------------------------------------------------------------------

sub VFreeText1 (x%, y%, Farbe%, Text$, Font$)		'Text im Modus 13h
  if len(Font$)<771 or y%<0 or y%>197 then exit sub	'Parameter berprfen
  Hoe%=asc(Font$)					'Hhe auslesen
  Bre%=asc(mid$(Font$,2,1))				'Breite auslesen
  Pla%=asc(mid$(Font$,3,1))				'Zwischenrume lesen
  dim Maske%(0:7)					'Bitmaske erzeugen
  for i%=0 to 7: Maske%(i%)=2^(7-i%): next		'und initialisieren
  for Buchst%=1 to len(Text$)				'den Text abarbeiten
    BuchstZ%=ascii(mid$(Text$,Buchst%,1))*Hoe%+4	'Position in Font$
    BuchstX%=x%+(Buchst%-1)*(Bre%+Pla%) 		'x fr diesen Buchst.
    for FFStrOU%=0 to Hoe%-1
      TextByte%=ascii(mid$(Font$,BuchstZ%+FFStrOU%,1))	'ein Byte von Font$
      BuchstY%=y%+FFStrOU%
      for FFStrLR%=0 to Bre%-1
	if (TextByte% and Maske%(FFStrLR%)) then	'wenn Bit gesetzt ist
	  poke BuchstY%*320+BuchstX%+FFStrLR%, Farbe%	'Punkt zeichnen
	end if
      next						'nchster Punkt
    next						'nchste Zeile
  next							'nchster Buchstabe
end sub

'----------------------------------------------------------------------------

sub VFreeText2 (x%, y%, Farbe%, Text$, Font$)		'flexibler Text
  if len(Font$)<771 or y%<0 or y%>197 then exit sub
  Hoe%=asc(Font$)					'Hhe auslesen
  Bre%=asc(mid$(Font$,2,1))				'Breite Leerzeichen
  Pla%=asc(mid$(Font$,3,1))				'Breite Zwischenrume
  BuchstX%=x%
  dim Maske%(0:7)					'Bitmaske erzeugen
  for i%=0 to 7: Maske%(i%)=2^i%: next			'und initialisieren
  for Buchst%=1 to len(Text$)				'den Text abarbeiten
    BuchstZ%=ascii(mid$(Text$,Buchst%,1))*Hoe%+4	'Position in Font$
    for FFStrOU%=0 to Hoe%-1
      TextByte%=ascii(mid$(Font$,BuchstZ%+FFStrOU%,1))	'ein Byte aus Font$
      if TextByte%=0 then				'Leerz. bergehen
      elseif TextByte%>127 then: Gox%=8			'und sonst die Breite
      elseif TextByte%>63 then : Gox%=max%(Gox%,7)	'auswerten
      elseif TextByte%>31 then : Gox%=max%(Gox%,6)
      elseif TextByte%>15 then : Gox%=max%(Gox%,5)
      elseif TextByte%>7 then  : Gox%=max%(Gox%,4)
      elseif TextByte%>3 then  : Gox%=max%(Gox%,3)
      elseif TextByte%>1 then  : Gox%=max%(Gox%,2)
      elseif TextByte%=1 then  : Gox%=max%(Gox%,1)
      end if
      BuchstY%=y%+FFStrOU%
      for FFStrLR%=0 to 7
	if (TextByte% and Maske%(FFStrLR%)) then	'wenn Bit gesetzt ist
	  poke BuchstY%*320+BuchstX%+FFStrLR%, Farbe%	'Punkt zeichnen
	end if
      next						'nchster Punkt
    next						'nchste Zeile
    if Gox%=0 then					'ein Leerzeichen?
      incr BuchstX%,Bre%-Pla%
    else
      incr BuchstX%,Gox%+Pla%				'plus variable Breite
      Gox%=0
    end if
  next							'nchster Buchstabe
end sub
