'FREEFONT.INC fr PowerBasic ab Version 3.2
'Freie Schriftarten fr jeden beliebigen Grafikmodus inklusive VGA-Modus 13h.
'Public Domain von Thiemo Mttig, Hauptstr. 11, 02627 Hochkirch

'----------------------------------------------------------------------------

function LadeFF$ (Dateiname$)				'Schriftart laden
  if instr(Dateiname$,".")=0 then
    Dateiname$=Dateiname$+".FF1"			'Endung ergnzen
  end if
  Dateinummer%=freefile					'nchste Dateinummer
  open Dateiname$ for binary as Dateinummer%
    if lof(Dateinummer%)=0 then
      close Dateinummer%: kill Dateiname$		'leere Datei lschen
      exit function
    end if
    get$ Dateinummer%, 8174, Daten$			'alle Daten auslesen
  close Dateinummer%
  if (len(Daten$) mod 256)=0 then
    function = chr$(len(Daten$)\256,8,1) + Daten$	'fr Binrdateien
  else
    function = Daten$					'fr FF-Schriften
  end if
end function

'----------------------------------------------------------------------------

function FFAttribut% (Font$, Nummer%)			'Schrift-Attribute
  function = ascii(mid$(Font$,Nummer%,1))
end function

'----------------------------------------------------------------------------

sub FreeText1 (x%, y%, Farbe%, Text$, Font$)		'normaler Text
  if len(Font$)<771 then exit sub			'gltige Schriftart?
  dim TPtr as byte ptr, FPtr as byte ptr		'Pointer erzeugen
  TPtr=strptr32(Text$)					'Pointer des Textes
  FPtr32???=strptr32(Font$)+3				'Pointer des Fonts
  FPtr=FPtr32???-3: Hoe%=@FPtr				'Parameter auslesen
  incr FPtr: Bre%=@FPtr: incr FPtr: Pla%=@FPtr
  for Buchst%=1 to len(Text$)				'den Text abarbeiten
    BuchstX%=x%+(Buchst%-1)*(Bre%+Pla%)
    BuchstZ%=@TPtr*Hoe%					'und auslesen
    for FFStrOU%=0 to Hoe%-1
      FPtr=FPtr32???+BuchstZ%+FFStrOU%			'FontPointer setzen
      TextByte%=@FPtr					'und auslesen
      BuchstY%=y%+FFStrOU%
      for FFStrLR%=0 to Bre%-1
	if bit(TextByte%,7-FFStrLR%) then		'wenn Bit gesetzt
	  pset (BuchstX%+FFStrLR%, BuchstY%), Farbe%	'Punkt setzen
	end if
      next						'nchstes Bit
    next						'nchste Zeile
    incr TPtr						'Text-Pointer erhhen
  next							'nchster Buchstabe
end sub

'----------------------------------------------------------------------------

sub FreeText2 (x%, y%, Farbe%, Text$, Font$)		'flexible Schrift
  if len(Font$)<771 then exit sub
  dim TPtr as byte ptr, FPtr as byte ptr		'Pointer erzeugen
  TPtr=strptr32(Text$)					'Pointer des Textes
  FPtr32???=strptr32(Font$)+3				'Pointer des Fonts
  FPtr=FPtr32???-3: Hoe%=@FPtr				'Parameter auslesen
  incr FPtr: Bre%=@FPtr: incr FPtr: Pla%=@FPtr
  BuchstX%=x%
  for Buchst%=1 to len(Text$)				'den Text abarbeiten
    BuchstZ%=@TPtr*Hoe%					'und auslesen
    for FFStrOU%=0 to Hoe%-1
      FPtr=FPtr32???+BuchstZ%+FFStrOU%			'FontPointer setzen
      TextByte%=@FPtr					'und auslesen
      BuchstY%=y%+FFStrOU%
      if TextByte%=0 then				'Leerz. bergehen
      elseif TextByte%>127 then: Gox%=8			'und sonst die Breite
      elseif TextByte%>63 then : Gox%=max%(Gox%,7)	'auswerten
      elseif TextByte%>31 then : Gox%=max%(Gox%,6)
      elseif TextByte%>15 then : Gox%=max%(Gox%,5)
      elseif TextByte%>7 then  : Gox%=max%(Gox%,4)
      elseif TextByte%>3 then  : Gox%=max%(Gox%,3)
      elseif TextByte%>1 then  : Gox%=max%(Gox%,2)
      elseif TextByte%=1 then  : Gox%=max%(Gox%,1)
      end if
      for FFStrLR%=0 to 7
	if bit(TextByte%,FFStrLR%) then
	  pset (BuchstX%+FFStrLR%, BuchstY%), Farbe%	'Punkt zeichnen
	end if
      next						'nchster Punkt
    next						'nchste Zeile
    if Gox%=0 then					'ein Leerzeichen?
      incr BuchstX%,Bre%-Pla%
    else
      incr BuchstX%,Gox%+Pla%
      Gox%=0
    end if
    incr TPtr						'Text-Pointer erhhen
  next							'nchster Buchstabe
end sub

'----------------------------------------------------------------------------

sub VFreeText1 (x%, y%, Farbe%, Text$, Font$)		'fr den Modus 13h
  if len(Font$)<771 or y%<0 or y%>197 then exit sub	'gltige Schriftart?
  dim TPtr as byte ptr, FPtr as byte ptr		'Pointer erzeugen
  TPtr=strptr32(Text$)					'Pointer des Textes
  FPtr32???=strptr32(Font$)+3				'Pointer des Fonts
  FPtr=FPtr32???-3: Hoe%=@FPtr				'Parameter auslesen
  incr FPtr: Bre%=@FPtr: incr FPtr: Pla%=@FPtr
  for Buchst%=1 to len(Text$)				'den Text abarbeiten
    BuchstX%=x%+(Buchst%-1)*(Bre%+Pla%)
    BuchstZ%=@TPtr*Hoe%					'und auslesen
    for FFStrOU%=0 to Hoe%-1
      FPtr=FPtr32???+BuchstZ%+FFStrOU%			'FontPointer setzen
      TextByte%=@FPtr					'und auslesen
      BuchstY??=(y%+FFStrOU%)*320+BuchstX%
      for FFStrLR%=0 to Bre%-1
	if bit(TextByte%,7-FFStrLR%) then
	  poke BuchstY??+FFStrLR%, Farbe%		'Punkt zeichnen
	end if
      next						'nchstes Bit
    next						'nchste Zeile
    incr TPtr						'Text-Pointer erhhen
  next							'nchster Buchstabe
end sub

'----------------------------------------------------------------------------

sub VFreeText2 (x%, y%, Farbe%, Text$, Font$)		'fr den Modus 13h
  if len(Font$)<771 or y%<0 or y%>197 then exit sub
  dim TPtr as byte ptr, FPtr as byte ptr		'Pointer erzeugen
  TPtr=strptr32(Text$)					'Pointer des Textes
  FPtr32???=strptr32(Font$)+3				'Pointer des Fonts
  FPtr=FPtr32???-3: Hoe%=@FPtr				'Parameter auslesen
  incr FPtr: Bre%=@FPtr: incr FPtr: Pla%=@FPtr
  BuchstX%=x%
  for Buchst%=1 to len(Text$)				'den Text abarbeiten
    BuchstZ%=@TPtr*Hoe%					'und auslesen
    for FFStrOU%=0 to Hoe%-1
      FPtr=FPtr32???+BuchstZ%+FFStrOU%			'FontPointer setzen
      TextByte%=@FPtr					'und auslesen
      BuchstY??=(y%+FFStrOU%)*320+BuchstX%
      if TextByte%=0 then				'Leerz. bergehen
      elseif TextByte%>127 then: Gox%=8			'und sonst die Breite
      elseif TextByte%>63 then : Gox%=max%(Gox%,7)	'auswerten
      elseif TextByte%>31 then : Gox%=max%(Gox%,6)
      elseif TextByte%>15 then : Gox%=max%(Gox%,5)
      elseif TextByte%>7 then  : Gox%=max%(Gox%,4)
      elseif TextByte%>3 then  : Gox%=max%(Gox%,3)
      elseif TextByte%>1 then  : Gox%=max%(Gox%,2)
      elseif TextByte%=1 then  : Gox%=max%(Gox%,1)
      end if
      for FFStrLR%=0 to 7
	if bit(TextByte%,FFStrLR%) then
	  poke BuchstY??+FFStrLR%, Farbe%		'Punkt zeichnen
	end if
      next						'nchster Punkt
    next						'nchste Zeile
    if Gox%=0 then					'ein Leerzeichen?
      incr BuchstX%,Bre%-Pla%
    else
      incr BuchstX%,Gox%+Pla%				'plus variable Breite
      Gox%=0
    end if
    incr TPtr						'Text-Pointer erhhen
  next							'nchster Buchstabe
end sub
