'BEISPI08.BAS fr PowerBasic ab Version 2.1
'Ein kleiner Textbetrachter im Grafikmodus 12. Der berblendeffekt ist nur zu
'sehen, wenn Sie die Bild-Tasten, Pos1 oder Ende drcken.
'Public Domain von Thiemo Mttig, Hauptstr. 11, 02627 Hochkirch

'----------------------------------------------------------------------------

'$compile exe "Beispi08.Exe"				'EXE-Datei erzeugen
$cpu 80286						'luft ab 286er
$float emulate						'ohne Coprozessor
$com 0							'Puffer minimieren
$sound 1
$string 8						'kleinere Stringlnge
$lib iprint off, com off, lpt off			'Bibliotheken aus
$lib graph on, herc off, cga off, ega off, vga on	'nur Grafik behalten
$error all off						'Fehlerprfung aus
defint a-z						'alles auf Integer

BackR= 0: BackG= 0: BackB=31				'Hintergrundfarbe
TextR=63: TextG=63: TextB=63				'Textfarbe

open "Norm16.Fnt" for binary as 1			'Schriftdatei ffnen
get$ #1,8174,Schrift$: close				'und komplett laden
Hoe=len(Schrift$)\256					'die Hhe der Schrift
Zeilen=480\Hoe-1					'maximale Zeilenzahl
if (len(Schrift$) mod 256)=0 then
  Schrift$=chr$(Hoe,8,1)+Schrift$			'evtl. Header dazu
end if

Datei$=command$						'Parameter auswerten
if Datei$="" then Datei$="Beispi08.Bas"

dim T$(1:1000)						'Array fr den Text
open Datei$ for input as #1: i=0			'Textdatei ffnen
while not eof(1)
  incr i: line input #1,T$(i)				'Textdatei einlesen
  T$(i)=left$(T$(i)+space$(80),80)
wend: close
First=1: FirstMax=max%(1,i-Zeilen): FirstAlt=3

screen 12: line(0,0)-(639,479),4,bf			'Grafikmodus ein
palette 6,6						'Palette rcksetzen
call Rgb (4, BackR, BackG, BackB)			'neue Farben
call Rgb (6, BackR, BackG, BackB)
call Rgb (7, TextR, TextG, TextB)

do
  if abs(First-FirstAlt)>1 then				'bei groen Sprngen
    TextF=1-TextF					'Farbe wechseln
    out &H3C4,2: out &H3C5,TextF+1			'Bitverknpfung
    for i=0 to Zeilen
      call FreeTextX(0,i*Hoe,T$(i+First),Schrift$)	'den Text darstellen
    next: FirstAlt=First
    for i=0 to 63
      call Rgb (5+TextF,BackR+(TextR-BackR)*i/63,_	'Farben berblenden
        BackG+(TextG-BackG)*i/63,BackB+(TextB-BackB)*i/63)
      call Rgb (6-TextF,TextR+(BackR-TextR)*i/63,_
        TextG+(BackG-TextG)*i/63,TextB+(BackB-TextB)*i/63)
      reg 1,&H8600: reg 3,0: reg 4,5000
      call interrupt &H15				'kurze Verzgerung
    next
  elseif First<>FirstAlt then				'bei kleinen Sprngen
    out &H3C4,2: out &H3C5,TextF+1			'Bitverknpfung
    for i=0 to Zeilen
      call FreeTextX(0,i*Hoe,T$(i+First),Schrift$)	'den Text darstellen
    next: FirstAlt=First
  end if

  i$="": while i$="": i$=inkey$: wend			'auf Taste warten
  select case i$
    case chr$(27): exit loop				'Esc = Programmende
    case chr$(0,71): First=1				'Position 1
    case chr$(0,79): First=FirstMax			'Ende
    case chr$(0,73): First=max%(First-25,1)		'Bild nach oben
    case chr$(0,81): First=min%(First+25,FirstMax)	'Bild nach unten
    case chr$(0,72): First=max%(First-1,1)		'Pfeil nach oben
    case chr$(0,80): First=min%(First+1,FirstMax)	'Pfeil nach unten
  end select
loop

def seg: screen 0,,0,0: color 7,0: cls			'Programmende

'----------------------------------------------------------------------------

sub Rgb (Farbe, r, g, b)
  out 968,Farbe: out 969,r: out 969,g: out 969,b	'Palettenfarbe ndern
end sub

'----------------------------------------------------------------------------

sub FreeTextX (x, y, Text$, Font$)
  TSeg&=strseg(Text$): TPtr&=strptr(Text$)-1		'Pointer von Text$
  FSeg&=strseg(Font$): FPtr&=strptr(Font$)+3		'Pointer von Font$
  Hoe=asc(Font$): c=Hoe-1
  dim FByte(0:c)					'Zwischenspeicher
  BuchstY&=x+y*80
  for Buchst=1 to len(Text$)				'den Text abarbeiten
    def seg=TSeg&					'Zugriff auf Text$
    BuchstZ&=FPtr&+peek(TPtr&+Buchst)*Hoe
    def seg=FSeg&					'Zugriff auf Font$
    for i=0 to c: FByte(i)=peek(BuchstZ&+i): next	'Buchstabe einlesen
    def seg=&HA000					'Zugriff auf Bild
    for i=0 to c: poke BuchstY&+i*80,FByte(i): next	'Buchstabe zeichnen
    incr BuchstY&
  next							'nchster Buchstabe
end sub